//*----------------------------------------------------------------------------
// timer.c
//*----------------------------------------------------------------------------
#include "timer.h"
//*----------------------------------------------------------------------------
// Set a timer
//*----------------------------------------------------------------------------
void timer_set(struct timer *t, u32 interval)
{
  t->interval = interval;
  t->start = clock_time();
}
/*---------------------------------------------------------------------------*/
// Reset the timer with the same interval
//*----------------------------------------------------------------------------
void timer_reset(struct timer *t)
{
  t->start += t->interval;
}
/*---------------------------------------------------------------------------*/
// Restart the timer from the current point in time
//*----------------------------------------------------------------------------
void timer_restart(struct timer *t)
{
  t->start = clock_time();
}
/*---------------------------------------------------------------------------*/
// Check if a timer has expired.
//*----------------------------------------------------------------------------
u32 timer_expired(struct timer *t)
{
  return (u32)(clock_time() - t->start) >= (u32)t->interval;
}
/*---------------------------------------------------------------------------*/
