unit uDebug;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDebug = class(TForm)
    Memo: TMemo;
    procedure MemoDblClick(Sender: TObject);
  private
  public
    procedure F(const Form: string; const Args: array of const);
    procedure S(s1: string);
    procedure D(n: integer);
    procedure H(n: integer);
    procedure B(b: boolean);
    procedure C;
    procedure TH(txt: string; n: integer);
    procedure DUMP(var arr: array of byte; anz: integer=-1);
    procedure BUFF(buf: PByteArray; anz: integer);
    procedure L(c: char = '=');
  end;

var
  Debug: TDebug;

implementation

{$R *.DFM}
{==========================================================}
procedure TDebug.F(const Form: string; const Args: Array of const);
begin
  Memo.Lines.Add(Format(Form, Args));
end;
{==========================================================}
procedure TDebug.C;
begin
  Memo.Lines.Clear;
end;
{==========================================================}
procedure TDebug.S(s1: string);
begin
  Memo.Lines.Add(s1);
end;
{==========================================================}
procedure TDebug.D(n: integer);
begin
  Memo.Lines.Add(IntToStr(n));
end;
{==========================================================}
procedure TDebug.H(n: integer);
begin
  Memo.Lines.Add(IntToHex(n, 8));
end;
{==========================================================}
procedure TDebug.B(b: boolean);
begin
  if b then Memo.Lines.Add('TRUE')
       else Memo.Lines.Add('FALSE');
end;
{==========================================================}
procedure TDebug.L(c: char = '=');
begin
  Memo.Lines.Add(StringOfChar(c, 60));
end;
{==========================================================}
procedure TDebug.TH(txt: string; n: integer);
begin
  Memo.Lines.Add(txt + ': ' +IntToHex(n, 8));
end;
{==========================================================}
procedure TDebug.DUMP(var arr: array of byte; anz: integer=-1);
var sAnz, sTmp: string;
    adr, i: integer;
    blk, ln: integer;
begin
  if anz=-1 then anz:=Length(arr);
  adr:=0;
  Memo.Lines.Add('Anzahl: '+IntToStr(anz));
  blk:=anz div 16; if blk * 16 <> anz then inc(blk);

  for ln:=0 to blk-1 do begin
    sTmp:=IntToHex(ln * 16, 4)+': ';
    for i:=0 to 15 do begin
      if (ln * 16 + i < anz) then sTmp:=sTmp+' '+IntToHex(arr[ln * 16 + i], 2)
                             else sTmp:=sTmp+' ..';
    end;
    sTmp:=sTmp+'  ';
    for i:=0 to 15 do begin
      if (ln * 16 + i < anz) then begin
        if arr[ln * 16 +i] in [32..125] then sTmp:=sTmp+chr(arr[ln *16 + i])
                                        else sTmp:=sTmp+'.';     
      end;
    end;

    Memo.Lines.Add(sTmp);
  end;
end;
{==========================================================}
procedure TDebug.BUFF(buf: PByteArray; anz: integer);
var sAnz, sTmp: string;
    adr, i: integer;
    blk, ln: integer;
begin
  adr:=0;
  blk:=anz div 16; if blk * 16 <> anz then inc(blk);

  for ln:=0 to blk-1 do begin
    sTmp:=IntToHex(ln * 16, 4)+': ';
    for i:=0 to 15 do begin
      if (ln * 16 + i < anz) then sTmp:=sTmp+' '+IntToHex(buf^[ln * 16 + i], 2)
                             else sTmp:=sTmp+' ..';
    end;
    sTmp:=sTmp+'  ';
    for i:=0 to 15 do begin
      if (ln * 16 + i < anz) then begin
        if buf^[ln * 16 +i] in [32..125] then sTmp:=sTmp+chr(buf^[ln *16 + i])
                                         else sTmp:=sTmp+'.';
      end;
    end;

    Memo.Lines.Add(sTmp);
  end;
end;
{==========================================================}
procedure TDebug.MemoDblClick(Sender: TObject);
begin
  Memo.Clear;
end;
{==========================================================}
end.
